<template>
  <form v-on:submit.prevent>
    <input type="search" :value="query" @keypress="notifyChanged" name="search" placeholder="Start typing to search..." autofocus>
  </form>
</template>

<script>
  import { debounce } from 'lodash'

  export default {
    name: 'search-form',
    props: ['initialQuery'],
    created () {
      this.setInputValue(this.initialQuery)
    },
    watch: {
      '$route': 'setValueFromRoute'
    },
    data: function (argument) {
      return {
        query: ''
      }
    },
    methods: {
      setValueFromRoute (router) {
        this.setInputValue(router.query.q)
      },
      setInputValue (val) {
        this.query = val
        this.$emit('search', val)
      },
      notifyChanged: debounce(function (e) {
        const value = e.target.value

        this.$router.push({path: '/', query: { q: value }})
        this.setInputValue(value)
      }, 500)
    }
  }
</script>

<style scoped>
  input {
    -webkit-appearance: none;
    width: 100%;
    padding: 1rem;
    background-color: #f4f4f4;
    border-style: none;
    border-width: 0;
  }
</style>
